1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
31 if test -z "$TEST_OUTPUT_DIRECTORY"
33 # Similarly, override this to store the test-results subdir
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
54 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
60 # Disallow the use of abbreviated options in the test suite by default
61 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
63 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
67 ################################################################
68 # It appears that people try to run tests without building...
69 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
72 if test -n "$GIT_TEST_INSTALLED"
74 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
76 echo >&2 'error: you do not seem to have built git yet.'
81 # Parse options while taking care to leave $@ intact, so we will still
82 # have all the original command line options when executing the test
83 # script again for '--tee' and '--verbose-log' below.
88 if test -n "$store_arg_to"
90 eval $store_arg_to=\$opt
97 -d|--d|--de|--deb|--debu|--debug)
99 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
101 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
102 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
104 store_arg_to=run_list
107 run_list=${opt#--*=} ;;
108 -h|--h|--he|--hel|--help)
110 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
113 verbose_only=${opt#--*=}
115 -q|--q|--qu|--qui|--quie|--quiet)
116 # Ignore --quiet under a TAP::Harness. Saying how many tests
117 # passed without the ok/not ok details is always an error.
118 test -z "$HARNESS_ACTIVE" && quiet=t ;;
125 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
134 valgrind_only=${opt#--*=}
142 GIT_TEST_CHAIN_LINT=1 ;;
144 GIT_TEST_CHAIN_LINT=0 ;;
157 echo "error: --stress does not accept an argument: '$opt'" >&2
158 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
166 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
175 stress_limit=${opt#--*=}
176 case "$stress_limit" in
178 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
186 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
191 if test -n "$store_arg_to"
193 echo "error: $prev_opt requires an argument" >&2
197 if test -n "$valgrind_only"
199 test -z "$valgrind" && valgrind=memcheck
200 test -z "$verbose" && verbose_only="$valgrind_only"
201 elif test -n "$valgrind"
203 test -z "$verbose_log" && verbose=t
213 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
214 TEST_NAME="$(basename "$0" .sh)"
215 TEST_NUMBER="${TEST_NAME%%-*}"
216 TEST_NUMBER="${TEST_NUMBER#t}"
217 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
218 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
219 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
220 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
221 case "$TRASH_DIRECTORY" in
222 /*) ;; # absolute path is good
223 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
226 # If --stress was passed, run this test repeatedly in several parallel loops.
227 if test "$GIT_TEST_STRESS_STARTED" = "done"
229 : # Don't stress test again.
230 elif test -n "$stress"
232 if test "$stress" != t
235 elif test -n "$GIT_TEST_STRESS_LOAD"
237 job_count="$GIT_TEST_STRESS_LOAD"
238 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
241 job_count=$((2 * $job_count))
246 mkdir -p "$TEST_RESULTS_DIR"
247 stressfail="$TEST_RESULTS_BASE.stress-failed"
252 kill $job_pids 2>/dev/null
259 while test $job_nr -lt "$job_count"
262 GIT_TEST_STRESS_STARTED=done
263 GIT_TEST_STRESS_JOB_NR=$job_nr
264 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
267 kill $test_pid 2>/dev/null
273 while ! test -e "$stressfail" &&
274 { test -z "$stress_limit" ||
275 test $cnt -le $stress_limit ; }
277 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
282 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
284 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
285 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
290 job_pids="$job_pids $!"
291 job_nr=$(($job_nr + 1))
296 if test -f "$stressfail"
299 echo "Log(s) of failed test run(s):"
300 for failed_job_nr in $(sort -n "$stressfail")
302 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
303 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
305 rm -rf "$TRASH_DIRECTORY.stress-failed"
307 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
313 # if --tee was passed, write the output not only to the terminal, but
314 # additionally to the file test-results/$BASENAME.out, too.
315 if test "$GIT_TEST_TEE_STARTED" = "done"
317 : # do not redirect again
320 mkdir -p "$TEST_RESULTS_DIR"
322 # Make this filename available to the sub-process in case it is using
324 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
325 export GIT_TEST_TEE_OUTPUT_FILE
327 # Truncate before calling "tee -a" to get rid of the results
328 # from any previous runs.
329 >"$GIT_TEST_TEE_OUTPUT_FILE"
331 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
332 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
333 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
337 if test -n "$trace" && test -n "$test_untraceable"
339 # '-x' tracing requested, but this test script can't be reliably
340 # traced, unless it is run with a Bash version supporting
341 # BASH_XTRACEFD (introduced in Bash v4.1).
343 # Perform this version check _after_ the test script was
344 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
345 # '--verbose-log', so the right shell is checked and the
346 # warning is issued only once.
347 if test -n "$BASH_VERSION" && eval '
348 test ${BASH_VERSINFO[0]} -gt 4 || {
349 test ${BASH_VERSINFO[0]} -eq 4 &&
350 test ${BASH_VERSINFO[1]} -ge 1
354 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
356 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
360 if test -n "$trace" && test -z "$verbose_log"
365 # For repeatability, reset the environment to known value.
366 # TERM is sanitized below, after saving color control sequences.
371 export LANG LC_ALL PAGER TZ
374 # GIT_TEST_GETTEXT_POISON should not influence git commands executed
375 # during initialization of test-lib and the test repo. Back it up,
376 # unset and then restore after initialization is finished.
377 if test -n "$GIT_TEST_GETTEXT_POISON"
379 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
380 unset GIT_TEST_GETTEXT_POISON
383 # A call to "unset" with no arguments causes at least Solaris 10
384 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
385 # deriving from the command substitution clustered with the other
387 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
389 my $ok = join("|", qw(
401 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
402 print join("\n", @vars);
405 unset XDG_CONFIG_HOME
407 TEST_AUTHOR_LOCALNAME=author
408 TEST_AUTHOR_DOMAIN=example.com
409 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
410 GIT_AUTHOR_NAME='A U Thor'
411 TEST_COMMITTER_LOCALNAME=committer
412 TEST_COMMITTER_DOMAIN=example.com
413 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
414 GIT_COMMITTER_NAME='C O Mitter'
415 GIT_MERGE_VERBOSITY=5
416 GIT_MERGE_AUTOEDIT=no
417 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
418 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
419 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
422 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
424 export GIT_TRACE_BARE
426 check_var_migration () {
427 # the warnings and hints given from this helper depends
428 # on end-user settings, which will disrupt the self-test
429 # done on the test framework itself.
430 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
434 old_name=$1 new_name=$2
435 eval "old_isset=\${${old_name}:+isset}"
436 eval "new_isset=\${${new_name}:+isset}"
438 case "$old_isset,$new_isset" in
440 echo >&2 "warning: $old_name is now $new_name"
441 echo >&2 "hint: set $new_name too during the transition period"
442 eval "$new_name=\$$old_name"
446 # echo >&2 "warning: $old_name is now $new_name"
447 # echo >&2 "hint: remove $old_name"
452 check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
453 check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
454 check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
456 # Use specific version of the index file format
457 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
459 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
460 export GIT_INDEX_VERSION
463 # Add libc MALLOC and MALLOC_PERTURB test
464 # only if we are not executing the test with valgrind
465 if test -n "$valgrind" ||
466 test -n "$TEST_NO_MALLOC_CHECK"
468 setup_malloc_check () {
471 teardown_malloc_check () {
475 setup_malloc_check () {
476 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
477 export MALLOC_CHECK_ MALLOC_PERTURB_
479 teardown_malloc_check () {
480 unset MALLOC_CHECK_ MALLOC_PERTURB_
484 # Protect ourselves from common misconfiguration to export
485 # CDPATH into the environment
491 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
499 # A regexp to match 5, 35 and 40 hexdigits
500 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
501 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
505 _z40=0000000000000000000000000000000000000000
509 EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
510 EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
519 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
520 # when case-folding filenames
521 u200c=$(printf '\342\200\214')
523 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
525 # Each test should start with something like this, after copyright notices:
527 # test_description='Description of this test...
528 # This test checks if command xyzzy does the right thing...
531 test "x$TERM" != "xdumb" && (
533 tput bold >/dev/null 2>&1 &&
534 tput setaf 1 >/dev/null 2>&1 &&
535 tput sgr0 >/dev/null 2>&1
541 # Save the color control sequences now rather than run tput
542 # each time say_color() is called. This is done for two
544 # * TERM will be changed to dumb
545 # * HOME will be changed to a temporary directory and tput
546 # might need to read ~/.terminfo from the original HOME
547 # directory to get the control sequences
548 # Note: This approach assumes the control sequences don't end
549 # in a newline for any terminal of interest (command
550 # substitutions strip trailing newlines). Given that most
551 # (all?) terminals in common use are related to ECMA-48, this
552 # shouldn't be a problem.
553 say_color_error=$(tput bold; tput setaf 1) # bold red
554 say_color_skip=$(tput setaf 4) # blue
555 say_color_warn=$(tput setaf 3) # brown/yellow
556 say_color_pass=$(tput setaf 2) # green
557 say_color_info=$(tput setaf 6) # cyan
558 say_color_reset=$(tput sgr0)
559 say_color_="" # no formatting for normal text
561 test -z "$1" && test -n "$quiet" && return
562 eval "say_color_color=\$say_color_$1"
564 printf "%s\\n" "$say_color_color$*$say_color_reset"
568 test -z "$1" && test -n "$quiet" && return
578 say_color error "error: $*"
585 error >&7 "bug in the test script: $*"
592 if test -n "$HARNESS_ACTIVE"
594 if test "$verbose" = t || test -n "$verbose_only"
596 printf 'Bail out! %s\n' \
597 'verbose mode forbidden under TAP harness; try --verbose-log'
602 test "${test_description}" != "" ||
603 error "Test script did not set test_description."
605 if test "$help" = "t"
607 printf '%s\n' "$test_description"
614 if test "$verbose_log" = "t"
616 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
617 elif test "$verbose" = "t"
621 exec 4>/dev/null 3>/dev/null
624 # Send any "-x" output directly to stderr to avoid polluting tests
625 # which capture stderr. We can do this unconditionally since it
626 # has no effect if tracing isn't turned on.
628 # Note that this sets up the trace fd as soon as we assign the variable, so it
629 # must come after the creation of descriptor 4 above. Likewise, we must never
630 # unset this, as it has the side effect of closing descriptor 4, which we
631 # use to show verbose tests to the user.
633 # Note also that we don't need or want to export it. The tracing is local to
634 # this shell, and we would not want to influence any shells we exec.
643 test_external_has_tap=0
647 # This is responsible for running the atexit commands even when a
648 # test script run with '--immediate' fails, or when the user hits
649 # ctrl-C, i.e. when 'test_done' is not invoked at all.
650 test_atexit_handler || code=$?
651 if test -n "$GIT_EXIT_OK"
655 echo >&5 "FATAL: Unexpected exit with code $code"
662 # Disable '-x' tracing, because with some shells, notably dash, it
663 # prevents running the cleanup commands when a test script run with
664 # '--verbose-log -x' is interrupted.
665 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
667 # The user-facing functions are loaded from a separate file so that
668 # test_perf subshells can have them too
669 . "$TEST_DIRECTORY/test-lib-functions.sh"
671 # You are not expected to call test_ok_ and test_failure_ directly, use
672 # the test_expect_* functions instead.
675 if test -n "$write_junit_xml"
677 write_junit_xml_testcase "$*"
679 test_success=$(($test_success + 1))
680 say_color "" "ok $test_count - $@"
684 if test -n "$write_junit_xml"
686 junit_insert="<failure message=\"not ok $test_count -"
687 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
688 junit_insert="$junit_insert $(xml_attr_encode \
689 "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
691 test-tool path-utils skip-n-bytes \
692 "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
694 printf '%s\n' "$@" | sed 1d
696 junit_insert="$junit_insert</failure>"
697 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
699 junit_insert="$junit_insert<system-err>$(xml_attr_encode \
700 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
702 write_junit_xml_testcase "$1" " $junit_insert"
704 test_failure=$(($test_failure + 1))
705 say_color error "not ok $test_count - $1"
707 printf '%s\n' "$*" | sed -e 's/^/# /'
708 test "$immediate" = "" || { finalize_junit_xml; GIT_EXIT_OK=t; exit 1; }
711 test_known_broken_ok_ () {
712 if test -n "$write_junit_xml"
714 write_junit_xml_testcase "$* (breakage fixed)"
716 test_fixed=$(($test_fixed+1))
717 say_color error "ok $test_count - $@ # TODO known breakage vanished"
720 test_known_broken_failure_ () {
721 if test -n "$write_junit_xml"
723 write_junit_xml_testcase "$* (known breakage)"
725 test_broken=$(($test_broken+1))
726 say_color warn "not ok $test_count - $@ # TODO known breakage"
730 test "$debug" = "" || eval "$1"
733 match_pattern_list () {
736 test -z "$*" && return 1
747 match_test_selector_list () {
752 test -z "$1" && return 0
754 # Both commas and whitespace are accepted as separators.
760 # If the first selector is negative we include by default.
768 orig_selector=$selector
774 selector=${selector##?}
778 test -z "$selector" && continue
782 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
784 echo "error: $title: invalid non-numeric in range" \
785 "start: '$orig_selector'" >&2
788 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
790 echo "error: $title: invalid non-numeric in range" \
791 "end: '$orig_selector'" >&2
796 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
798 echo "error: $title: invalid non-numeric in test" \
799 "selector: '$orig_selector'" >&2
804 # Short cut for "obvious" cases
805 test -z "$include" && test -z "$positive" && continue
806 test -n "$include" && test -n "$positive" && continue
810 if test $arg -le ${selector#-}
816 if test $arg -ge ${selector%-}
822 if test ${selector%%-*} -le $arg \
823 && test $arg -le ${selector#*-}
829 if test $arg -eq $selector
840 maybe_teardown_verbose () {
841 test -z "$verbose_only" && return
842 exec 4>/dev/null 3>/dev/null
847 maybe_setup_verbose () {
848 test -z "$verbose_only" && return
849 if match_pattern_list $test_count $verbose_only
852 # Emit a delimiting blank line when going from
853 # non-verbose to verbose. Within verbose mode the
854 # delimiter is printed by test_expect_*. The choice
855 # of the initial $last_verbose is such that before
856 # test 1, we do not print it.
857 test -z "$last_verbose" && echo >&3 ""
860 exec 4>/dev/null 3>/dev/null
863 last_verbose=$verbose
866 maybe_teardown_valgrind () {
867 test -z "$GIT_VALGRIND" && return
868 GIT_VALGRIND_ENABLED=
871 maybe_setup_valgrind () {
872 test -z "$GIT_VALGRIND" && return
873 if test -z "$valgrind_only"
875 GIT_VALGRIND_ENABLED=t
878 GIT_VALGRIND_ENABLED=
879 if match_pattern_list $test_count $valgrind_only
881 GIT_VALGRIND_ENABLED=t
886 test "$trace" = t && {
887 test "$verbose" = t || test "$verbose_log" = t
891 # This is a separate function because some tests use
892 # "return" to end a test_expect_success block early
893 # (and we want to make sure we run any cleanup like
895 test_eval_inner_ () {
896 # Do not add anything extra (including LF) after '$*'
903 # If "-x" tracing is in effect, then we want to avoid polluting stderr
904 # with non-test commands. But once in "set -x" mode, we cannot prevent
905 # the shell from printing the "set +x" to turn it off (nor the saving
906 # of $? before that). But we can make sure that the output goes to
909 # There are a few subtleties here:
911 # - we have to redirect descriptor 4 in addition to 2, to cover
914 # - the actual eval has to come before the redirection block (since
915 # it needs to see descriptor 4 to set up its stderr)
917 # - likewise, any error message we print must be outside the block to
918 # access descriptor 4
920 # - checking $? has to come immediately after the eval, but it must
921 # be _inside_ the block to avoid polluting the "set -x" output
924 test_eval_inner_ "$@" </dev/null >&3 2>&4
933 if test "$test_eval_ret_" != 0 && want_trace
935 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
937 return $test_eval_ret_
944 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
945 # turn off tracing for this test-eval, as it simply creates
946 # confusing noise in the "-x" output
949 # 117 is magic because it is unlikely to match the exit
950 # code of other programs
951 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
952 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
954 BUG "broken &&-chain or run-away HERE-DOC: $1"
962 teardown_malloc_check
964 if test -z "$immediate" || test $eval_ret = 0 ||
965 test -n "$expecting_failure" && test "$test_cleanup" != ":"
968 test_eval_ "$test_cleanup"
969 teardown_malloc_check
971 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
979 test_count=$(($test_count+1))
982 if test -n "$write_junit_xml"
984 junit_start=$(test-tool date getnanos)
990 maybe_teardown_valgrind
991 maybe_teardown_verbose
992 if test -n "$GIT_TEST_TEE_OFFSET"
994 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
995 "$GIT_TEST_TEE_OUTPUT_FILE")
1002 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
1005 skipped_reason="GIT_SKIP_TESTS"
1007 if test -z "$to_skip" && test -n "$run_list" &&
1008 ! match_test_selector_list '--run' $test_count "$run_list"
1011 skipped_reason="--run"
1013 if test -z "$to_skip" && test -n "$test_prereq" &&
1014 ! test_have_prereq "$test_prereq"
1019 if test "$missing_prereq" != "$test_prereq"
1021 of_prereq=" of $test_prereq"
1023 skipped_reason="missing $missing_prereq${of_prereq}"
1028 if test -n "$write_junit_xml"
1030 message="$(xml_attr_encode "$skipped_reason")"
1031 write_junit_xml_testcase "$1" \
1032 " <skipped message=\"$message\" />"
1035 say_color skip >&3 "skipping test: $@"
1036 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1045 # stub; perf-lib overrides it
1046 test_at_end_hook_ () {
1050 write_junit_xml () {
1054 junit_have_testcase=
1058 printf '%s\n' "$@" >>"$junit_xml_path"
1061 xml_attr_encode () {
1062 printf '%s\n' "$@" | test-tool xml-encode
1065 write_junit_xml_testcase () {
1066 junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1068 junit_attrs="$junit_attrs classname=\"$this_test\""
1069 junit_attrs="$junit_attrs time=\"$(test-tool \
1070 date getnanos $junit_start)\""
1071 write_junit_xml "$(printf '%s\n' \
1072 " <testcase $junit_attrs>" "$@" " </testcase>")"
1073 junit_have_testcase=t
1076 finalize_junit_xml () {
1077 if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1079 test -n "$junit_have_testcase" || {
1080 junit_start=$(test-tool date getnanos)
1081 write_junit_xml_testcase "all tests skipped"
1084 # adjust the overall time
1085 junit_time=$(test-tool date getnanos $junit_suite_start)
1086 sed "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1087 <"$junit_xml_path" >"$junit_xml_path.new"
1088 mv "$junit_xml_path.new" "$junit_xml_path"
1090 write_junit_xml " </testsuite>" "</testsuites>"
1095 test_atexit_cleanup=:
1096 test_atexit_handler () {
1097 # In a succeeding test script 'test_atexit_handler' is invoked
1098 # twice: first from 'test_done', then from 'die' in the trap on
1100 # This condition and resetting 'test_atexit_cleanup' below makes
1101 # sure that the registered cleanup commands are run only once.
1102 test : != "$test_atexit_cleanup" || return 0
1105 test_eval_ "$test_atexit_cleanup"
1106 test_atexit_cleanup=:
1107 teardown_malloc_check
1113 # Run the atexit commands _before_ the trash directory is
1114 # removed, so the commands can access pidfiles and socket files.
1119 if test -z "$HARNESS_ACTIVE"
1121 mkdir -p "$TEST_RESULTS_DIR"
1123 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1125 success $test_success
1128 failed $test_failure
1133 if test "$test_fixed" != 0
1135 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1137 if test "$test_broken" != 0
1139 say_color warn "# still have $test_broken known breakage(s)"
1141 if test "$test_broken" != 0 || test "$test_fixed" != 0
1143 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1144 msg="remaining $test_remaining test(s)"
1146 test_remaining=$test_count
1147 msg="$test_count test(s)"
1149 case "$test_failure" in
1151 if test $test_external_has_tap -eq 0
1153 if test $test_remaining -gt 0
1155 say_color pass "# passed all $msg"
1158 # Maybe print SKIP message
1159 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1160 case "$test_count" in
1162 say "1..$test_count${skip_all:+ $skip_all}"
1165 test -z "$skip_all" ||
1166 say_color warn "$skip_all"
1167 say "1..$test_count"
1174 test -d "$TRASH_DIRECTORY" ||
1175 error "Tests passed but trash directory already removed before test cleanup; aborting"
1177 cd "$TRASH_DIRECTORY/.." &&
1178 rm -fr "$TRASH_DIRECTORY" || {
1179 # try again in a bit
1181 rm -fr "$TRASH_DIRECTORY"
1183 error "Tests passed but test cleanup failed; aborting"
1190 if test $test_external_has_tap -eq 0
1192 say_color error "# failed $test_failure among $msg"
1193 say "1..$test_count"
1201 if test -n "$valgrind"
1205 test "$1" = "$(readlink "$2")" || {
1213 while test -d "$2".lock
1215 say "Waiting for lock on $2."
1222 make_valgrind_symlink () {
1223 # handle only executables, unless they are shell libraries that
1224 # need to be in the exec-path.
1226 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1229 base=$(basename "$1")
1232 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1235 symlink_target="$GIT_BUILD_DIR/$base"
1238 # do not override scripts
1239 if test -x "$symlink_target" &&
1240 test ! -d "$symlink_target" &&
1241 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1243 symlink_target=../valgrind.sh
1247 symlink_target=../unprocessed-script
1249 # create the link, or replace it if it is out of date
1250 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1253 # override all git executables in TEST_DIRECTORY/..
1254 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1255 mkdir -p "$GIT_VALGRIND"/bin
1256 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1258 make_valgrind_symlink $file
1260 # special-case the mergetools loadables
1261 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1266 ls "$path"/git-* 2> /dev/null |
1269 make_valgrind_symlink "$file"
1273 PATH=$GIT_VALGRIND/bin:$PATH
1274 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1276 GIT_VALGRIND_MODE="$valgrind"
1277 export GIT_VALGRIND_MODE
1278 GIT_VALGRIND_ENABLED=t
1279 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1280 export GIT_VALGRIND_ENABLED
1281 elif test -n "$GIT_TEST_INSTALLED"
1283 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1284 error "Cannot run git from $GIT_TEST_INSTALLED."
1285 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1286 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1287 else # normal case, use ../bin-wrappers only unless $with_dashes:
1288 if test -n "$no_bin_wrappers"
1292 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1293 if ! test -x "$git_bin_dir/git"
1295 if test -z "$with_dashes"
1297 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1301 PATH="$git_bin_dir:$PATH"
1303 GIT_EXEC_PATH=$GIT_BUILD_DIR
1304 if test -n "$with_dashes"
1306 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1309 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1310 GIT_CONFIG_NOSYSTEM=1
1312 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1314 if test -z "$GIT_TEST_CMP"
1316 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1318 GIT_TEST_CMP="$DIFF -c"
1320 GIT_TEST_CMP="$DIFF -u"
1324 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1326 test -d "$GIT_BUILD_DIR"/templates/blt || {
1327 error "You haven't built things yet, have you?"
1330 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1332 echo >&2 'You need to build test-tool:'
1333 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1338 rm -fr "$TRASH_DIRECTORY" || {
1340 echo >&5 "FATAL: Cannot prepare test area"
1344 HOME="$TRASH_DIRECTORY"
1345 GNUPGHOME="$HOME/gnupg-home-not-used"
1346 export HOME GNUPGHOME
1348 if test -z "$TEST_NO_CREATE_REPO"
1350 test_create_repo "$TRASH_DIRECTORY"
1352 mkdir -p "$TRASH_DIRECTORY"
1355 # Use -P to resolve symlinks in our working directory so that the cwd
1356 # in subprocesses like git equals our $PWD (for pathname comparisons).
1357 cd -P "$TRASH_DIRECTORY" || exit 1
1360 this_test=${this_test%%-*}
1361 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1363 say_color info >&3 "skipping test $this_test altogether"
1364 skip_all="skip all tests in $this_test"
1368 if test -n "$write_junit_xml"
1370 junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1371 mkdir -p "$junit_xml_dir"
1372 junit_xml_base=${0##*/}
1373 junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1374 junit_attrs="name=\"${junit_xml_base%.sh}\""
1375 junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1376 date +%Y-%m-%dT%H:%M:%S)\""
1377 write_junit_xml --truncate "<testsuites>" " <testsuite $junit_attrs>"
1378 junit_suite_start=$(test-tool date getnanos)
1379 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1381 GIT_TEST_TEE_OFFSET=0
1385 # Provide an implementation of the 'yes' utility; the upper bound
1386 # limit is there to help Windows that cannot stop this loop from
1387 # wasting cycles when the downstream stops reading, so do not be
1388 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1389 # limit the output of the yes utility", 2016-02-02)
1399 while test $i -lt 99
1406 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1407 # thus needs to be set up really early, and set an internal variable
1408 # for convenience so the hot test_set_prereq() codepath doesn't need
1409 # to call "git env--helper" (via test_bool_env). Only do that work
1410 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1411 GIT_TEST_FAIL_PREREQS_INTERNAL=
1412 if test -n "$GIT_TEST_FAIL_PREREQS"
1414 if test_bool_env GIT_TEST_FAIL_PREREQS false
1416 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1417 test_set_prereq FAIL_PREREQS
1420 test_lazy_prereq FAIL_PREREQS '
1421 test_bool_env GIT_TEST_FAIL_PREREQS false
1425 # Fix some commands on Windows, and other OS-specific things
1429 # Windows has its own (incompatible) sort and find
1436 # git sees Windows-style pwd
1440 # no POSIX permissions
1441 # backslashes in pathspec are converted to '/'
1442 # exec does not inherit the PID
1443 test_set_prereq MINGW
1444 test_set_prereq NATIVE_CRLF
1445 test_set_prereq SED_STRIPS_CR
1446 test_set_prereq GREP_STRIPS_CR
1447 GIT_TEST_CMP=mingw_test_cmp
1450 test_set_prereq POSIXPERM
1451 test_set_prereq EXECKEEPSPID
1452 test_set_prereq CYGWIN
1453 test_set_prereq SED_STRIPS_CR
1454 test_set_prereq GREP_STRIPS_CR
1457 test_set_prereq REGEX_ILLSEQ
1458 test_set_prereq POSIXPERM
1459 test_set_prereq BSLASHPSPEC
1460 test_set_prereq EXECKEEPSPID
1463 test_set_prereq POSIXPERM
1464 test_set_prereq BSLASHPSPEC
1465 test_set_prereq EXECKEEPSPID
1469 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1470 test -z "$NO_PERL" && test_set_prereq PERL
1471 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1472 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1473 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1474 test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1475 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1476 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1478 if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1480 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1481 export GIT_TEST_GETTEXT_POISON
1482 unset GIT_TEST_GETTEXT_POISON_ORIG
1485 test_lazy_prereq C_LOCALE_OUTPUT '
1486 ! test_bool_env GIT_TEST_GETTEXT_POISON false
1489 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1491 GIT_TEST_CHECK_CACHE_TREE=true
1492 export GIT_TEST_CHECK_CACHE_TREE
1495 test_lazy_prereq PIPE '
1496 # test whether the filesystem supports FIFOs
1497 test_have_prereq !MINGW,!CYGWIN &&
1498 rm -f testfifo && mkfifo testfifo
1501 test_lazy_prereq SYMLINKS '
1502 # test whether the filesystem supports symbolic links
1503 ln -s x y && test -h y
1506 test_lazy_prereq FILEMODE '
1507 test "$(git config --bool core.filemode)" = true
1510 test_lazy_prereq CASE_INSENSITIVE_FS '
1511 echo good >CamelCase &&
1512 echo bad >camelcase &&
1513 test "$(cat CamelCase)" != good
1516 test_lazy_prereq FUNNYNAMES '
1517 test_have_prereq !MINGW &&
1519 "FUNNYNAMES tab embedded" \
1520 "FUNNYNAMES \"quote embedded\"" \
1522 embedded" 2>/dev/null &&
1524 "FUNNYNAMES tab embedded" \
1525 "FUNNYNAMES \"quote embedded\"" \
1527 embedded" 2>/dev/null
1530 test_lazy_prereq UTF8_NFD_TO_NFC '
1531 # check whether FS converts nfd unicode to nfc
1532 auml=$(printf "\303\244")
1533 aumlcdiar=$(printf "\141\314\210")
1535 test -f "$aumlcdiar"
1538 test_lazy_prereq AUTOIDENT '
1539 sane_unset GIT_AUTHOR_NAME &&
1540 sane_unset GIT_AUTHOR_EMAIL &&
1541 git var GIT_AUTHOR_IDENT
1544 test_lazy_prereq EXPENSIVE '
1545 test -n "$GIT_TEST_LONG"
1548 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1549 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1552 test_lazy_prereq USR_BIN_TIME '
1553 test -x /usr/bin/time
1556 test_lazy_prereq NOT_ROOT '
1561 test_lazy_prereq JGIT '
1565 # SANITY is about "can you correctly predict what the filesystem would
1566 # do by only looking at the permission bits of the files and
1567 # directories?" A typical example of !SANITY is running the test
1568 # suite as root, where a test may expect "chmod -r file && cat file"
1569 # to fail because file is supposed to be unreadable after a successful
1570 # chmod. In an environment (i.e. combination of what filesystem is
1571 # being used and who is running the tests) that lacks SANITY, you may
1572 # be able to delete or create a file when the containing directory
1573 # doesn't have write permissions, or access a file even if the
1574 # containing directory doesn't have read or execute permissions.
1576 test_lazy_prereq SANITY '
1577 mkdir SANETESTD.1 SANETESTD.2 &&
1579 chmod +w SANETESTD.1 SANETESTD.2 &&
1580 >SANETESTD.1/x 2>SANETESTD.2/x &&
1581 chmod -w SANETESTD.1 &&
1582 chmod -r SANETESTD.1/x &&
1583 chmod -rx SANETESTD.2 ||
1584 BUG "cannot prepare SANETESTD"
1586 ! test -r SANETESTD.1/x &&
1587 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1590 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1591 rm -rf SANETESTD.1 SANETESTD.2 ||
1592 BUG "cannot clean SANETESTD"
1596 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1597 GIT_UNZIP=${GIT_UNZIP:-unzip}
1598 test_lazy_prereq UNZIP '
1603 run_with_limited_cmdline () {
1604 (ulimit -s 128 && "$@")
1607 test_lazy_prereq CMDLINE_LIMIT '
1608 test_have_prereq !MINGW,!CYGWIN &&
1609 run_with_limited_cmdline true
1612 run_with_limited_stack () {
1613 (ulimit -s 128 && "$@")
1616 test_lazy_prereq ULIMIT_STACK_SIZE '
1617 test_have_prereq !MINGW,!CYGWIN &&
1618 run_with_limited_stack true
1622 git version --build-options |
1623 sed -ne "s/^$1: //p"
1626 test_lazy_prereq LONG_IS_64BIT '
1627 test 8 -le "$(build_option sizeof-long)"
1630 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1631 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1633 test_lazy_prereq CURL '
1637 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1638 # which will not work with other hash algorithms and tests that work but don't
1639 # test anything meaningful (e.g. special values which cause short collisions).
1640 test_lazy_prereq SHA1 '
1641 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1644 test_lazy_prereq REBASE_P '
1645 test -z "$GIT_TEST_SKIP_REBASE_P"